import pl.kielce.tu.RPN;

import java.util.LinkedList;
 

public class RPNCalc {

    private LinkedList<Double> stack = new LinkedList<>();
	
	private void add() {
		Double argument1 = stack.pop(), argument2 = stack.pop();
		stack.push(argument1 + argument2);
	}
	
	private void subtract() {
		Double argument1 = stack.pop(), argument2 = stack.pop();
		stack.push(argument2 - argument1);
	}
	
	private void multiply() {
		Double argument1 = stack.pop(), argument2 = stack.pop();
		stack.push(argument1*argument2);
	}
	
	private void divide() {
		Double argument1 = stack.pop(), argument2 = stack.pop();
		stack.push(argument2/argument1);
	}

    public Double calculate(String expr) {
        RPN rpn = new RPN();
        LinkedList<String> RPNExpr = rpn.getRPN(expr);
        while (!RPNExpr.isEmpty()) {
            String str = RPNExpr.removeFirst();
            switch (str) {
                case "+":
                    add();
                    break;
                case "-":
                    subtract();
                    break;
                case "*":
                    multiply();
                    break;
                case "/":
                    divide();
                    break;
                default:
                    stack.push(Double.valueOf(str));
            }
        }

        return stack.pop();
    }

    public static void main(String[] args) {
		RPNCalc test = new RPNCalc();
		String[] params = {"5-2","(23+5)*3","23*5+3/4","(23+8)*(5+6)",
				"(35+25)/(23-90)","25/(23-90)","3*(2+(40-3)*7)+5"};
		for(String x: params) 
			System.out.println(x + " = " + test.calculate(x));		
	}
}