import static org.junit.Assert.*;
import org.junit.*;
import java.util.*;
import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

import pl.kielce.tu.RPN;


@RunWith(Parameterized.class)
public class RPNTest {
	private static final String COM = "Błąd dla wyrażenia: ";
	private String expression;
	private String result;

	public RPNTest(String expression, String result) {
		this.expression = expression;
		this.result = result;
	}
	
	@Parameters
	public static Collection<Object[]> data() {
		return Arrays.asList(new Object[][]{{"(23+5)*3","[23, 5, +, 3, *]"},
				{"23*5+3/4","[23, 5, *, 3, 4, /, +]"},
				{"(23+8)*(5+6)","[23, 8, +, 5, 6, +, *]"},
				{"(35+25)/(23-90)","[35, 25, +, 23, 90, -, /]"},
				{"25/(23-90)","[25, 23, 90, -, /]"},
				{"3*(2+(40-3)*7)+5","[3, 2, 40, 3, -, 7, *, +, *, 5, +]"},
				{"(3.5+2.5)*1.4", "[3.5, 2.5, +, 1.4, *]"},
				{"(2.5+1.5)*4","[2.5, 1.5, +, 4, *]"},
				});
	}
	
	@Test
	public void testExpressions() {
		RPN rpn = new RPN();
		assertEquals(COM+expression,result,rpn.getRPN(expression).toString());
	}
}
